/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2019 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : Config_TPU1_user.c
* Version      : 1.7.0
* Device(s)    : R5F5651EDxFP
* Description  : This file implements device driver for Config_TPU1.
* Creation Date: 2019-11-14
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "Config_TPU1.h"
/* Start user code for include. Do not edit comment generated here */
#include "Config_RSPI0.h"
#include "sound_effector.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: R_Config_TPU1_Create_UserInit
* Description  : This function adds user code after initializing the TPU1 channel
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

void R_Config_TPU1_Create_UserInit(void)
{
    /* Start user code for user init. Do not edit comment generated here */
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_Config_TPU1_tgi1a_interrupt
* Description  : This function is TGI1A interrupt service routine
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

#if FAST_INTERRUPT_VECTOR == VECT_PERIB_INTB144
#pragma interrupt r_Config_TPU1_tgi1a_interrupt(vect=VECT(PERIB,INTB144),fint)
#else
#pragma interrupt r_Config_TPU1_tgi1a_interrupt(vect=VECT(PERIB,INTB144))
#endif
static void r_Config_TPU1_tgi1a_interrupt(void)
{
    /* Start user code for r_Config_TPU1_tgi1a_interrupt. Do not edit comment generated here */
	
	//ch0 send & receive

#if (OUT_CH == 2)
	g_rspi0_send_data = g_next_send_data.ch0;
#elif (OUT_CH == 1)
	g_rspi0_send_data = g_next_send_data;
#endif
	
#ifdef DEBUG2

	if(g_rspi0_flag == 0)
	{
		g_rspi0_flag = 0x1;
	
		setpsw_i();	//multiple interrupt enable
	
		//RSPI-ch0 receive&send
		RSPI0.SPCR.BYTE |= 0xf0;
		
		g_rspi0_success_count++;
	}
	else
	{
		g_rspi0_error_count++;
	}

#else

	g_rspi0_flag = 0x1;
	
	setpsw_i();	//multiple interrupt enable
	
	//RSPI-ch0 receive&send
	RSPI0.SPCR.BYTE |= 0xf0;
	
#endif

    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_Config_TPU1_tgi1b_interrupt
* Description  : This function is TGI1B interrupt service routine
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/

#if FAST_INTERRUPT_VECTOR == VECT_PERIB_INTB135
#pragma interrupt r_Config_TPU1_tgi1b_interrupt(vect=VECT(PERIB,INTB135),fint)
#else
#pragma interrupt r_Config_TPU1_tgi1b_interrupt(vect=VECT(PERIB,INTB135))
#endif
static void r_Config_TPU1_tgi1b_interrupt(void)
{
    /* Start user code for r_Config_TPU1_tgi1b_interrupt. Do not edit comment generated here */
	
	//ch1 send & receive

#if (OUT_CH == 2)
	g_rspi0_send_data = g_next_send_data.ch1;
#endif

#ifdef DEBUG2

	if(g_rspi0_flag == 0)
	{
		g_rspi0_flag = 0x1;
	
		setpsw_i();	//multiple interrupt enable
	
		//RSPI-ch0 receive&send
		RSPI0.SPCR.BYTE |= 0xf0;
		
		g_rspi0_success_count++;
	}
	else
	{
		g_rspi0_error_count++;
	}

#else

	g_rspi0_flag = 0x1;
	
	setpsw_i();	//multiple interrupt enable
	
	//RSPI-ch0 receive&send
	RSPI0.SPCR.BYTE |= 0xf0;

#endif
	
	if(g_outbuf_rp != g_outbuf_wp)
	{	
		g_next_send_data = g_outbuf[g_outbuf_rp];
		
		g_outbuf_rp++;
		if(g_outbuf_rp >= OUTBUF_SIZE) g_outbuf_rp = 0;
	}
	else
	{
		g_next_send_data = g_zero_data;
		
#ifdef DEBUG
		g_rspi_null_data_count++;
#endif

	}
	
	g_sampling_period_flag = 0;		//flag clear
	g_sampling_counter++;			//counter increment

    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */   




